#include <algorithm>

#include "Vec3f.h"
#include "Vec3d.h"
#include "Vec3Hf.h"
#include "Quaternion.h"

using namespace std;

namespace CGLA
{

Vec3f::Vec3f(const Quaternion& q) :
	ArithVec3Float<float,Vec3f>(q.qv[0],q.qv[1],q.qv[2]) {
}

Vec3f::Vec3f(const Vec3d& v) :
	ArithVec3Float<float,Vec3f>(static_cast<float>(v[0]),
	                            static_cast<float>(v[1]),
	                            static_cast<float>(v[2])) {
}

Vec3f::Vec3f(const Vec4f& v) :
	ArithVec3Float<float,Vec3f>(v[0],v[1],v[2]) {
}

}
