#include "backdrop.h"
#include "util.h"
#include "texture.h"

Texture bluetile("paper.jpg");
Texture gras("bkglayer.png");

using namespace std;

void Backdrop::draw()
{

	if (stars==0xffffffff)
	{
		stars = glGenLists(1);
		glNewList( stars, GL_COMPILE );
		glBegin( GL_POINTS );

		for(int a=0; a<1000; a++)
		{
			double brightness = frand()*0.7+0.3;
			glColor3f( brightness, brightness, brightness );
			glVertex2f( frand()*40.0-20.0, 20+20*(1.0-pow(frand(),2.0)) );
		}
		glEnd();
		glEndList();
	}

	bluetile.bind();
	//  glPushMatrix();
	//  glRotatef( 30, 0,0,1 );
	//  glScalef( 0.3,0.3,1.0);
	glBegin(GL_QUADS);
	glColor3f(0.0,0.0,0.0);
	glTexCoord2f( -6, 6 );
	glVertex2f(-40, 40 );
	glTexCoord2f( 6, 6 );
	glVertex2f( 40, 40 );

	glColor3f(0.2 * bkgFactor,0.2  * bkgFactor,0.8 * bkgFactor);
	glTexCoord2f( 6, 3 );
	glVertex2f( 40, 20 );
	glTexCoord2f( -6, 3 );
	glVertex2f(-40, 20 );


	glColor3f(0.2 * bkgFactor,0.2 * bkgFactor,0.8 * bkgFactor);
	glTexCoord2f( -6, 3 );
	glVertex2f(-40, 20 );
	glTexCoord2f( 6, 3 );
	glVertex2f( 40, 20 );

	glColor3f(1 * bkgFactor,1 * bkgFactor,1 * bkgFactor);
	glTexCoord2f( 6, -3 );
	glVertex2f( 40, -10 );
	glTexCoord2f( -6, -3 );
	glVertex2f(-40, -10 );


	glEnd();
	bluetile.unbind();
	//  glPopMatrix();

	glEnable( GL_BLEND );
	gras.bind();
	glBegin(GL_QUADS);
	glColor3f(0.8,0.5,0.8);
	glTexCoord2f(0,0.01);
	glVertex2f( -10, -6 );
	glTexCoord2f(1,0.01);
	glVertex2f(  10, -6 );
	glTexCoord2f(1,0.99);
	glVertex2f(  10, -10 );
	glTexCoord2f(0,0.99);
	glVertex2f( -10, -10 );
	glEnd();
	gras.unbind();

	glPointSize(3.0);
	glEnable( GL_POINT_SMOOTH );

	glCallList( stars );

//   glBegin(GL_QUADS);

//   // ground
//   glColor3f(0.4,0.5,0.3);
//   glVertex2f(-100, -10 );
//   glVertex2f( 100, -10 );
//   glColor3f(0.3,0.4,0.2);
//   glVertex2f( 100, -8 );
//   glVertex2f(-100, -8 );
//   glEnd();

// // perlin noise debug code
//   glBegin(GL_LINES);
//   glColor3f(1,1,1);
//   double step = 0.1;
//   for(float f=-20.0; f<20.0;f+=step )
//     {
//       glVertex2f( f, noise1( f ) );
//       glVertex2f( f+step, noise1( f+step) );
//     }
//   glEnd();

	cloudtexture.bind();
	glEnable(GL_BLEND);
	glBegin(GL_QUADS);
	for( int i=0; i<clouds.size(); i++)
	{
		clouds[i].draw();
	}
	glEnd();
	glDisable(GL_BLEND);
	cloudtexture.unbind();
}


void Backdrop::update( float time, float delta )
{
	bkgFactor = (time - 5.0) / 10.0;
	if (bkgFactor>1.0)
		bkgFactor=1.0;
	if (bkgFactor<0.2)
		bkgFactor=0.0;

	for( int i=0; i<clouds.size(); i++)
	{
		clouds[i].update( time, delta );
	}
	if (clouds.size() < maxcloudcount)
	{
		printf("f=%f\n", frand() );
		clouds.push_back( Cloud(0) );
	}
}
