#ifndef _BACKDROP_H
#define _BACKDROP_H

#include <vector>
#include "texture.h"
#include <Vec2d.h>
#include "util.h"

using namespace CGLA;

class Cloud {
public:
Vec2d position;
Vec2d size;
Vec2d speed;
int cloudType;

Cloud(int force_out_of_sight)
{
	cloudType = rand() % 4;
	position =  Vec2d( -20.0+40.0*frand(), frand()* 15.0+5.0 );
	if (force_out_of_sight)
		position[0] += 40.0;
	size = Vec2d( 4.0, 2.0 );
	speed = Vec2d( -(position[1]+20.0) / 30.0 + frand()*0.3, 0 );
}

void update( float time, float delta )
{
	position += delta * speed;
	if (position[0]< -20.0)
		*this = Cloud( 1 );
}

void draw()
{
	float v0;
	float v1;
	v0 = cloudType/4.0;
	v1 = (cloudType+1)/4.0;

	glColor3f(1,1,1);
	glTexCoord2f(0,v0);
	glVertex2f( position[0], position[1] );
	glTexCoord2f(1,v0);
	glVertex2f( position[0]+size[0], position[1] );
	glTexCoord2f(1,v1);
	glVertex2f( position[0]+size[0], position[1]-size[1] );
	glTexCoord2f(0,v1);
	glVertex2f( position[0], position[1]-size[1] );
}
};

class Backdrop {
public:
double bkgFactor;   // color factor.. 0 means black background
GLuint stars;

Texture cloudtexture;
std::vector<Cloud> clouds;
int maxcloudcount;
Backdrop() : cloudtexture("cloud.png")
{
	bkgFactor = 0.0;
	stars = 0xffffffff;
	maxcloudcount = 6;
};

void initcloud( int i );
void draw();
void update( float time, float delta );
};

#endif
