#include "fontrenderer.h"
#include <string.h>

void FontRenderer::init( std::string filename )
{
	font = new FTGLTextureFont( filename.c_str() );
	font->FaceSize(90);

	ofont = new FTGLOutlineFont( filename.c_str() );
	ofont->FaceSize(90);
}

void FontRenderer::draw( std::string text, Vec3d fillColor, Vec3d outlineColor, double alpha, int halign, int valign )
{
	//      glList = glGenLists(1);
	//      glNewList( glList, GL_COMPILE);
	//      outlineFont->Render("abcdefghjkashdkjahsd kahksdhaskjd\nomgwtf");
	//      float a,b,c,d,e,f;
	//      outlineFont->BBox("test",a,b,c,d,e,f );
	//      printf("%f %f %f %f %f %f\n",a,b,c,d,e,f );
	//      glEndList();
	//    }

	glPushMatrix();
	//glTranslatef(0,-10,0);
	glScalef(0.01,0.01,1.0);
	//  glColor3f(1,1,1);

	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	float x1,y1,z1,x2,y2,z2;
	font->BBox( text.c_str(), x1,y1,z1,x2,y2,z2 );

	if ( halign == -1 )
		glTranslatef( -x1, 0, 0 );
	else if ( halign == 0 )
		glTranslatef( -(x1+x2)/2.0, 0, 0 );
	else if ( halign == 1 )
		glTranslatef( -x2, 0, 0 );

	if ( valign == -1 )
		glTranslatef( 0, -y1, 0 );
	else if ( valign == 0 )
		glTranslatef( 0, -(y1+y2)/2.0, 0 );
	else if ( valign == 1 )
		glTranslatef( 0, -y2, 0 );

	glPushMatrix();
	glColor4f( outlineColor[0], outlineColor[1], outlineColor[2], alpha );
	glTranslatef(2.0,-2.0,0.0);
	font->Render(text.c_str());
	glPopMatrix();

	glPushMatrix();
	glColor4f( fillColor[0], fillColor[1], fillColor[2], alpha );
	font->Render(text.c_str());
	glPopMatrix();

//    glColor4f( outlineColor[0], outlineColor[1], outlineColor[2], alpha );

//    glPushMatrix();
//    glLineWidth(1.0);
//    glEnable(GL_BLEND);
//    glEnable(GL_LINE_SMOOTH);
//    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
//    ofont->Render(text.c_str());
//    glPopMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	//  glCallList( glList );
	glPopMatrix();
}
