#ifndef FONTRENDERER_H
#define FONTRENDERER_H

#include <string>
#include <FTGL/FTGL.h>
#include <FTGL/FTGLTextureFont.h>
#include <FTGL/FTGLOutlineFont.h>
#include "Vec3d.h"

using namespace CGLA;

class FontRenderer {
public:
FTGLTextureFont* font;
FTGLOutlineFont* ofont;

void init( std::string filename );
void draw( std::string text,  Vec3d fillColor, Vec3d outlineColor, double alpha, int halign=0, int valign=0 );

FontRenderer( std::string filename )
{
	init( filename );
}

~FontRenderer()
{
	free( font );
}
};

#endif
